%define upstream_name    Server-Starter
%define upstream_version 0.32

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 2

Summary:    A superdaemon for hot-deploying server programs
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}
Source0:    http://www.cpan.org/modules/by-module/Server/%{upstream_name}-%{upstream_version}.tar.gz

BuildRequires: perl(ExtUtils::CBuilder)
BuildRequires: perl(ExtUtils::MakeMaker) >= 6.420.0
BuildRequires: perl(Getopt::Long)
BuildRequires: perl(List::MoreUtils)
BuildRequires: perl(Module::Build)
BuildRequires: perl(Proc::Wait3)
BuildRequires: perl(Scope::Guard)
BuildRequires: perl(Test::Requires)
BuildRequires: perl(Test::TCP) >= 2.0.0
BuildArch:  noarch

%description
It is often a pain to write a server program that supports graceful
restarts, with no resource leaks. the Server::Starter manpage, solves the
problem by splitting the task into two. One is the start_server manpage, a
script provided as a part of the module, which works as a superdaemon that
binds to zero or more TCP ports or unix sockets, and repeatedly spawns the
server program that actually handles the necessary tasks (for example,
responding to incoming commenctions). The spawned server programs under the
Server::Starter manpage call accept(2) and handle the requests.

To gracefully restart the server program, send SIGHUP to the superdaemon.
The superdaemon spawns a new server program, and if (and only if) it starts
up successfully, sends SIGTERM to the old server program.

By using the Server::Starter manpage it is much easier to write a
hot-deployable server. Following are the only requirements a server program
to be run under the Server::Starter manpage should conform to:

%prep
%setup -q -n %{upstream_name}-%{upstream_version}

%build
%__perl Build.PL --installdirs=vendor

./Build


%install
./Build install --destdir=%{buildroot}
perl -i -lape 's{^#!perl\s*$}{#!%{_bindir}/perl} if $. == 1' %{buildroot}/%{_bindir}/start_server

%files
%doc Changes META.yml MYMETA.yml README.md
%{_mandir}/man3/*
%{perl_vendorlib}/*
%{_bindir}/start_server
/usr/share/man/man1/start_server.1.bz2


%changelog
* Wed Jul 12 2017 bb2 <bb2> - 0.320.0-2pclos2017
- rebuild against updates

